(* Program to Calculate the traces of Moller scattering neglecting
   the electron mass. 

 Last Version: 08/05/2019
 Author: Jorge C. Romao
 email: jorge.romao@ist.utl.pt
*)


Remove["Global`*"]

(* Definitions *)
dm[mu_]:=DiracMatrix[mu]
dm[5]:=DiracMatrix[5]
ds[p_]:=DiracSlash[p]
mt[mu_,nu_]:=MetricTensor[mu,nu]
fv[p_,mu_]:=FourVector[p,mu]
epsilon[a_,b_,c_,d_]:=LeviCivita[a,b,c,d]
id[n_]:=IdentityMatrix[n]
sp[p_,q_]:=ScalarProduct[p,q]
li[mu_]:=LorentzIndex[mu]
prop[p_,m_]:=ds[p]+m
PR=(1 + dm[5])/2
PL=(1 - dm[5])/2


Line1:= prop[p3,m] . dm[mu] .  prop[p1,m] . dm[nu]  

Line2:= prop[p4,m] . dm[mu] .  prop[p2,m] . dm[nu]

Line3:= prop[p4,m] . dm[mu] .  prop[p1,m] . dm[nu]  

Line4:= prop[p3,m] . dm[mu] .  prop[p2,m] . dm[nu]

Line5:= prop[p3,m] . dm[mu] .  prop[p1,m] . dm[nu] . prop[p4,m] . dm[mu] . prop[p2,m] . dm[nu] 



ans1= Simplify[Contract[Tr[Line1] Tr[Line2]]]

ans2= Simplify[Contract[Tr[Line3] Tr[Line4]]]

ans3= Simplify[Contract[Tr[Line5]]]


  ans=(ans1/t^2+ans2/u^2-2*ans3/u/t)/. m->0

ans= ans/4


dot={sp[p1,p2]->s/2,sp[p3,p4]->s/2,sp[p1,p3]->-t/2,sp[p2,p4]->-t/2,sp[p1,p4]->-u/2,sp[p2,p3]->-u/2}

mandel={s-> -t -u}

res= ans /. dot

dsigdOmg= e^4 res /. mandel //Simplify

